#
#               Common Quantification
#                        of
#               A Categorical Variable
#

import numpy
import numpy as np

#
#       X:      The categorical variable to bu quantified
#       NCat:   The number of categories in the variable
#       NCase:  The number of cases
#

def OneHotEncoding( X, NCat, NCase ):
        G = [0]*NCase                   #  A list for the indicator matrix
        for i in range(0, NCase):
                if (X[i] < 1) or (X[i] > NCat):
                         print("Category is out of the range...X[%d] = %d"%(i,X[i]))
                         raise "CatRange"
                        
                G[i] = []
                for j in range(0, NCat):
                    if (X[i] == j + 1):
                        G[i].append(1)
                    else:
                        G[i].append(0)
 
        G = np.array(G)

        return G
